//  Copyright (c) 2020 Gonzalo Müller Bravo.
//  Licensed under the MIT License (MIT), see LICENSE.txt
/* eslint-disable global-require */

const rulesNames = ['required', 'required-warn', 'required-error', 'another-required', 'other-required', 'invalid', 'invalid-warn', 'invalid-error', 'another-invalid', 'other-invalid']

module.exports = {
  addRegexRuleName: (ruleName) => {
    if (/invalid|required/i.test(ruleName)) {
      if (/^(required|required-warn|required-error|another-required|other-required|invalid|invalid-warn|invalid-error|another-invalid|other-invalid)$/i
        .test(ruleName)) {
        throw new Error(`"${ruleName}" can not be used as eslint-plugin-regex rule name`)
      }
      rulesNames.push(ruleName)
    }
  },
  rules: new Proxy({}, {
    ownKeys: () => rulesNames,
    getOwnPropertyDescriptor: () => ({ configurable: true, enumerable: true }),
    get(rules, ruleName) {
      return /invalid/i.test(ruleName)
        ? require('./rules/invalid-regex-rule.js')
        : /required/i.test(ruleName)
          ? require('./rules/required-regex-rule.js')
          : undefined
    }
  })
}
